import { world, system, ItemStack } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
function Vector(x, y, z) {
    let Vector = {
        x: x,
        y: y,
        z: z
    }
    return Vector
}
world.afterEvents.itemUse.subscribe(data => {
    if (data.itemStack.typeId == "blayy:builder_wand" && data.source.isSneaking == true) {
        let mode = new ActionFormData();
        mode.title("Select Mode");


        const options = [
            { label: "Circular Sides", texture: "textures/cwui/cs" },
            { label: "Ground", texture: "textures/cwui/g" },
            { label: "Hollow Sphere", texture: "textures/cwui/hs" },
            { label: "Outline Shape", texture: "textures/cwui/os" },
            { label: "Outline Side XZ", texture: "textures/cwui/os2" },
            { label: "Perpendicular Sides", texture: "textures/cwui/ps" },
            { label: "Pyramid", texture: "textures/cwui/p" },
            { label: "Solid Shape", texture: "textures/cwui/ss" }
        ];


        options.forEach(option => {
            mode.button(`§0<- ${option.label} ->`, option.texture);
        });

        mode.show(data.source).then(resp => {
            let eq = data.source.getComponent("equippable");


            if (resp.selection >= 0 && resp.selection < options.length) {
                system.run(() => {
                    eq.getEquipmentSlot("Mainhand").setLore([options[resp.selection].label]);
                });
            }
        });

    }
})
let once = 0
world.beforeEvents.itemUseOn.subscribe(data => {

    let player = data.source


    if (data.itemStack.typeId == "blayy:builder_wand" && data.itemStack.getLore()[0]) {
        let loc = data.block.location

        let eq = data.source.getComponent("equippable")

        if (data.itemStack.getLore()[1]) {
            let cords = data.itemStack.getLore()[1]
            let vec1 = new Vector(parseInt(cords.split(" ")[0]), parseInt(cords.split(" ")[1]), parseInt(cords.split(" ")[2]))
            let vec2 = new Vector(loc.x, loc.y + 1, loc.z)

            let blockId = `${cords.split(" ")[3]}`
            let ainv = 0
            let bq = 0
            let onc = 1
            if (data.itemStack.getLore()[0] == "Outline Side XZ") {
                for (let ix = Math.min(vec1.x, vec2.x); ix <= Math.max(vec1.x, vec2.x); ix++) {
                    for (let iz = Math.min(vec1.z, vec2.z); iz <= Math.max(vec1.z, vec2.z); iz++) {

                        if (ix === vec1.x || ix === vec2.x || iz === vec1.z || iz === vec2.z) {
                            if (player.dimension.getBlock({ x: ix, y: vec1.y, z: iz })?.getItemStack()?.typeId) {

                            } else {
                                system.run(() => {
                                    
                                })
                                bq++
                            }
                        }
                    }
                }
            }
            if (data.itemStack.getLore()[0] == "Ground") {
                for (let ix = Math.min(vec1.x, vec2.x); ix <= Math.max(vec1.x, vec2.x); ix++) {
                    for (let iz = Math.min(vec1.z, vec2.z); iz <= Math.max(vec1.z, vec2.z); iz++) {
                        if (player.dimension.getBlock({ x: ix, y: vec1.y, z: iz })?.getItemStack()?.typeId) {

                        } else {
                            system.run(() => {
                                
                            })

                            bq++
                        }
                    }
                }
            }
            const minX = Math.min(vec1.x, vec2.x);
            const maxX = Math.max(vec1.x, vec2.x);
            const minY = Math.min(vec1.y, vec2.y);
            const maxY = Math.max(vec1.y, vec2.y);
            const minZ = Math.min(vec1.z, vec2.z);
            const maxZ = Math.max(vec1.z, vec2.z);

            if (data.itemStack.getLore()[0] == "Outline Shape") {

                let heightDifference = vec1.y - vec2.y;


                let adjustedMinY = minY;
                let adjustedMaxY = maxY;


                if (heightDifference < 0) {
                    adjustedMaxY = maxY - 1;
                }


                if (heightDifference > 0) {
                    adjustedMinY = minY - 1;
                }


                for (let x = minX; x <= maxX; x++) {
                    for (let y = adjustedMinY; y <= adjustedMaxY; y++) {
                        for (let z = minZ; z <= maxZ; z++) {

                            const isBorder = x === minX || x === maxX || y === adjustedMinY || y === adjustedMaxY || z === minZ || z === maxZ;

                            let delay = ((x - minX) * (adjustedMaxY - adjustedMinY + 1) * (maxZ - minZ + 1)) +
                                ((y - adjustedMinY) * (maxZ - minZ + 1)) + (z - minZ);

                           




                                if (isBorder) {
                                    bq++
                                    system.run(() => {
                                        
                                    })
                                }



                          
                        }
                    }
                }


            }
            let rd;
            if (Math.abs(vec1.x - vec2.x) != 0) {
                rd = Math.abs(vec1.x - vec2.x)
            } else {
                rd = Math.abs(vec1.z - vec2.z)
            }
            const centerX = vec1.x;
            const centerY = vec1.y;
            const centerZ = vec1.z;
            let radius;
            if (data.itemStack.getLore()[0] == "Perpendicular Structures") {
                const usedCoordinates = new Set();

                radius = rd;

                for (let y = centerY - radius; y <= centerY + radius; y++) {

                    for (let angle = 0; angle <= 360; angle += 5) {
                        const radians = angle * (Math.PI / 180);
                        const x = Math.round(centerX + radius * Math.cos(radians));
                        const z = Math.round(centerZ + radius * Math.sin(radians));
                        const coordinateKey = `${Math.round(x)},${Math.round(z)}`;

                        if (Math.abs(x - centerX) === radius || Math.abs(z - centerZ) === radius) {


                            if (player.dimension.getBlock({ x: x, y: centerY, z: z })?.getItemStack()?.typeId) {
                                if (!usedCoordinates.has(coordinateKey)) {
                                    usedCoordinates.add(coordinateKey)
                                    bq++
                                }
                            } else {


                                system.run(() => {
                                    

                                })


                            }
                        }

                    }
                }
                bq = ((rd + 1) * (rd + 1)) * 4 - bq
            }
            if (data.itemStack.getLore()[0] == "Circular Sides") {
                const centerY = vec1.y;
                const centerX = vec1.x;
                const centerZ = vec1.z;
                radius = rd;
                const usedCoordinates = new Set();
                for (let angle = 0; angle <= 360; angle += 1) {
                    const radians = angle * (Math.PI / 180);
                    const x = Math.round(centerX + radius * Math.cos(radians));
                    const z = Math.round(centerZ + radius * Math.sin(radians));


                    const coordinateKey = `${Math.round(x)},${Math.round(z)}`;
                    if (!usedCoordinates.has(coordinateKey)) {
                        usedCoordinates.add(coordinateKey);



                        if (player.dimension.getBlock({ x: x, y: centerY, z: z })?.getItemStack()?.typeId) {

                        } else {
                            bq++
                            system.run(() => {
                                



                            })


                        }
                    }
                }

            }
            if (data.itemStack.getLore()[0] == "Hollow Sphere") {
                function createHollowSphere1(centerX, centerY, centerZ, radius) {
                    const diameter = radius * 2;
                    const minX = centerX - radius;
                    const minY = centerY - radius;
                    const minZ = centerZ - radius;
                    const maxX = centerX + radius;
                    const maxY = centerY + radius;
                    const maxZ = centerZ + radius;
                    const usedCoordinates = new Set();
                    for (let x = minX; x <= maxX; x++) {
                        for (let y = minY; y <= maxY; y++) {
                            for (let z = minZ; z <= maxZ; z++) {
                                const distance = Math.sqrt((x - centerX) ** 2 + (y - centerY) ** 2 + (z - centerZ) ** 2);

                                const coordinateKey = `${Math.round(x)},${Math.round(z)}`;
                                if (distance >= radius - 0.5 && distance <= radius + 0.5) {




                                    if (player.dimension.getBlock({ x: x, y: y, z: z })?.getItemStack()?.typeId) {

                                    } else {
                                        bq++
                                        system.run(() => {
                                            



                                        })


                                    }

                                }
                            }
                        }
                    }
                }

                const sphereCenterX = vec1.x;
                const sphereCenterY = vec1.y;
                const sphereCenterZ = vec1.z;
                const sphereRadius = rd;
                createHollowSphere1(sphereCenterX, sphereCenterY, sphereCenterZ, sphereRadius);

            }
            if (data.itemStack.getLore()[0] == "Pyramid") {

                let centerX = vec1.x;
                let centerY = vec1.y;
                let centerZ = vec1.z; 
                let radius = rd;  

                
                let pyramidHeight = radius;

                for (let y = 0; y < pyramidHeight; y++) {
                    
                    let currentLayerSize = radius - y;

                   
                    let minX = centerX - currentLayerSize;
                    let maxX = centerX + currentLayerSize;
                    let minZ = centerZ - currentLayerSize;
                    let maxZ = centerZ + currentLayerSize;

                    for (let x = minX; x <= maxX; x++) {
                        for (let z = minZ; z <= maxZ; z++) {
                          
                            const isBorder = (x === minX || x === maxX || z === minZ || z === maxZ);

                            let currentY = centerY + y; 

                            let delay = ((y) * (maxZ - minZ + 1) * pyramidHeight) + (x - minX) + (z - minZ);

                         
                               
                            if (!player.dimension.getBlock({ x: x, y: currentY, z: z })?.getItemStack()?.typeId) {

                                if (isBorder) {
                                    bq++
                                    system.run(() => {
                                        
                                    })
                                }
                               

                            }
                                
                            
                        }
                    }
                }

bq = bq+2
            }
            if (data.itemStack.getLore()[0] == "Solid Shape") {

                let heightDifference = vec1.y - vec2.y;


                let adjustedMinY = minY;
                let adjustedMaxY = maxY;


                if (heightDifference < 0) {
                    adjustedMaxY = maxY - 1;
                }


                if (heightDifference > 0) {
                    adjustedMinY = minY - 1;
                }


                for (let x = minX; x <= maxX; x++) {
                    for (let y = adjustedMinY; y <= adjustedMaxY; y++) {
                        for (let z = minZ; z <= maxZ; z++) {
                           

                                if (!player.dimension.getBlock({ x: x, y: y, z: z })?.getItemStack()?.typeId) {
 
                                    bq++
                                    system.run(() => {
                                        



                                    })


                                }
                        }
                    }
                }




            } 
            for (let i = 0; i < 35; i++) {
                const item = data.source.getComponent("inventory").container.getItem(i);
                if (item?.typeId == blockId) {
                    ainv += item.amount
                }

            };
            let confirm = new ActionFormData()
            confirm.button("text.confirm")
            confirm.body({ rawtext: [{ translate: "bw.qe" }, { text: `${bq}` }, { translate: `bw.b` }, { text: `\n` }, { translate: "bw.vp" }, { text: `${ainv}` }, { translate: `bw.b` }, { text: `\n` }, { translate: `bw.aveso` }] })
            system.runTimeout(() => {

                confirm.show(player).then(resp => {
                    if (resp.selection == 0) {
                        if (data.itemStack.getLore()[0] == "Outline Shape") {

                            let heightDifference = vec1.y - vec2.y;


                            let adjustedMinY = minY;
                            let adjustedMaxY = maxY;


                            if (heightDifference < 0) {
                                adjustedMaxY = maxY - 1;
                            }


                            if (heightDifference > 0) {
                                adjustedMinY = minY - 1;
                            }


                            for (let x = minX; x <= maxX; x++) {
                                for (let y = adjustedMinY; y <= adjustedMaxY; y++) {
                                    for (let z = minZ; z <= maxZ; z++) {

                                        const isBorder = x === minX || x === maxX || y === adjustedMinY || y === adjustedMaxY || z === minZ || z === maxZ;

                                        let delay = ((x - minX) * (adjustedMaxY - adjustedMinY + 1) * (maxZ - minZ + 1)) +
                                            ((y - adjustedMinY) * (maxZ - minZ + 1)) + (z - minZ);

                                        system.runTimeout(() => {

                                            


                                            if (isBorder) {
                                                player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run clear @s ${blockId} 0 1`);
                                                player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run setblock ${x} ${y} ${z} ${blockId}`);
                                            }


                                            player.runCommand(`execute unless entity @s[hasitem={item=${blockId}}] run particle minecraft:villager_angry ${x} ${y} ${z}`);
                                        }, delay);
                                    }
                                }
                            }

                        }
                        if (data.itemStack.getLore()[0] == "Ground") {

                            for (let ix = Math.min(vec1.x, vec2.x); ix <= Math.max(vec1.x, vec2.x); ix++) {
                                for (let iz = Math.min(vec1.z, vec2.z); iz <= Math.max(vec1.z, vec2.z); iz++) {
                                    onc++
                                    system.runTimeout(() => {
                                        
                                        player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${ix} ${vec1.y} ${iz} air run clear @s ${blockId} 0 1`);
                                        player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${ix} ${vec1.y} ${iz} air run setblock ${ix} ${vec1.y} ${iz} ${blockId}`);
                                    }, onc)
                                }
                            }
                        }
                        if (data.itemStack.getLore()[0] == "Outline Side XZ") {
                            for (let ix = Math.min(vec1.x, vec2.x); ix <= Math.max(vec1.x, vec2.x); ix++) {
                                for (let iz = Math.min(vec1.z, vec2.z); iz <= Math.max(vec1.z, vec2.z); iz++) {
                                    onc++
                                    system.runTimeout(() => {
                                        
                                        if (ix === vec1.x || ix === vec2.x || iz === vec1.z || iz === vec2.z) {

                                            player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${ix} ${vec1.y} ${iz} air run clear @s ${blockId} 0 1`);
                                            player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${ix} ${vec1.y} ${iz} air run setblock ${ix} ${vec1.y} ${iz} ${blockId}`);
                                        }
                                    }, onc)
                                }
                            }
                        }


                        if (data.itemStack.getLore()[0] == "Perpendicular Structures") {

                            const centerX = vec1.x;
                            const centerY = vec1.y;
                            const centerZ = vec1.z;
                            const radius = rd;

                            for (let y = centerY - radius; y <= centerY + radius; y++) {
                                for (let angle = 0; angle <= 360; angle += 5) {
                                    const radians = angle * (Math.PI / 180);
                                    const x = Math.round(centerX + radius * Math.cos(radians));
                                    const z = Math.round(centerZ + radius * Math.sin(radians));


                                    if (Math.abs(x - centerX) === radius || Math.abs(z - centerZ) === radius) {
                                        
                                        player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run clear @s ${blockId} 0 1`);
                                        player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run setblock ${x} ${y} ${z} ${blockId}`);

                                        player.runCommand(`execute unless entity @s[hasitem={item=${blockId}}] run particle minecraft:villager_angry ${x} ${y} ${z}`);
                                    }

                                }
                            }


                        }
                        if (data.itemStack.getLore()[0] == "Circular Sides") {
                            const centerX = vec1.x;
                            const centerY = vec1.y;
                            const centerZ = vec1.z;
                            const radius = rd;


                            for (let angle = 0; angle <= 360; angle += 1) {
                                const radians = angle * (Math.PI / 180);
                                const x = Math.round(centerX + radius * Math.cos(radians));
                                const z = Math.round(centerZ + radius * Math.sin(radians));



                                onc++;

                                system.runTimeout(() => {
                                    
                                    player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${centerY} ${z} air run clear @s ${blockId} 0 1`);
                                    player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${centerY} ${z} air run setblock ${x} ${centerY} ${z} ${blockId}`);
                                    player.runCommand(`execute unless entity @s[hasitem={item=${blockId}}] run particle minecraft:villager_angry ${x} ${centerY} ${z}`);
                                }, onc / 8);

                            }

                        }
                        if (data.itemStack.getLore()[0] == "Hollow Sphere") {
                            function createHollowSphere(centerX, centerY, centerZ, radius) {
                                const diameter = radius * 2;
                                const minX = centerX - radius;
                                const minY = centerY - radius;
                                const minZ = centerZ - radius;
                                const maxX = centerX + radius;
                                const maxY = centerY + radius;
                                const maxZ = centerZ + radius;

                                for (let x = minX; x <= maxX; x++) {
                                    for (let y = minY; y <= maxY; y++) {
                                        for (let z = minZ; z <= maxZ; z++) {
                                            const distance = Math.sqrt((x - centerX) ** 2 + (y - centerY) ** 2 + (z - centerZ) ** 2);
                                            if (distance >= radius - 0.5 && distance <= radius + 0.5) {

                                                onc++;

                                                system.runTimeout(() => {
                                                    
                                                    player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run clear @s ${blockId} 0 1`);
                                                    player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run setblock ${x} ${y} ${z} ${blockId}`);

                                                    player.runCommand(`execute unless entity @s[hasitem={item=${blockId}}] run particle minecraft:villager_angry ${x} ${y} ${z}`);
                                                }, onc / 2);
                                            }
                                        }
                                    }
                                }
                            }

                            const sphereCenterX = vec1.x;
                            const sphereCenterY = vec1.y;
                            const sphereCenterZ = vec1.z;
                            const sphereRadius = rd;
                            createHollowSphere(sphereCenterX, sphereCenterY, sphereCenterZ, sphereRadius);

                        }
                        if (data.itemStack.getLore()[0] == "Solid Shape") {

                            let heightDifference = vec1.y - vec2.y;


                            let adjustedMinY = minY;
                            let adjustedMaxY = maxY;


                            if (heightDifference < 0) {
                                adjustedMaxY = maxY - 1;
                            }


                            if (heightDifference > 0) {
                                adjustedMinY = minY - 1;
                            }


                            for (let x = minX; x <= maxX; x++) {
                                for (let y = adjustedMinY; y <= adjustedMaxY; y++) {
                                    for (let z = minZ; z <= maxZ; z++) {
                                        let delay = ((x - minX) * (adjustedMaxY - adjustedMinY + 1) * (maxZ - minZ + 1)) +
                                            ((y - adjustedMinY) * (maxZ - minZ + 1)) + (z - minZ);

                                        system.runTimeout(() => {

                                            

                                            player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run clear @s ${blockId} 0 1`);
                                            player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run setblock ${x} ${y} ${z} ${blockId}`);


                                            player.runCommand(`execute unless entity @s[hasitem={item=${blockId}}] run particle minecraft:villager_angry ${x} ${y} ${z}`);
                                        }, delay);
                                    }
                                }
                            }




                        } if (data.itemStack.getLore()[0] == "Pyramid") {


                            let centerX = vec1.x;
                            let centerY = vec1.y;
                            let centerZ = vec1.z; 
                            let radius = rd;  

                            
                            let pyramidHeight = radius;

                            for (let y = 0; y < pyramidHeight; y++) {
                                
                                let currentLayerSize = radius - y;

                               
                                let minX = centerX - currentLayerSize;
                                let maxX = centerX + currentLayerSize;
                                let minZ = centerZ - currentLayerSize;
                                let maxZ = centerZ + currentLayerSize;

                                for (let x = minX; x <= maxX; x++) {
                                    for (let z = minZ; z <= maxZ; z++) {
                                      
                                        const isBorder = (x === minX || x === maxX || z === minZ || z === maxZ);

                                        let currentY = centerY + y; 

                                        let delay = ((y) * (maxZ - minZ + 1) * pyramidHeight) + (x - minX) + (z - minZ);

                                        system.runTimeout(() => {
                                           
                                            

                                            
                                            if (isBorder) {
                                                player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${currentY} ${z} air run clear @s ${blockId} 0 1`);
                                                player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${currentY} ${z} air run setblock ${x} ${currentY} ${z} ${blockId}`);
                                                player.runCommand(`execute unless entity @s[hasitem={item=${blockId}}] run particle minecraft:villager_angry ${x} ${currentY} ${z}`);
                                            }

                                           
                                            
                                        }, delay);
                                    }
                                }
                            }

                            let tipX = centerX;
                            let tipY = centerY + pyramidHeight;
                            let tipZ = centerZ;
                            
                            system.runTimeout(() => {
                                
                                player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${tipX} ${tipY} ${tipZ} air run clear @s ${blockId} 0 1`);
                                player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${tipX} ${tipY} ${tipZ} air run setblock ${tipX} ${tipY} ${tipZ} ${blockId}`);
                            }, (pyramidHeight + 1) * 10);

                        }
                        if (data.itemStack.getLore()[0] == "Solid Shape") {
                            
                            let heightDifference = vec1.y - vec2.y;

                            let adjustedMinY = minY;
                            let adjustedMaxY = maxY;

                          
                            if (heightDifference < 0) {
                                adjustedMaxY = maxY - 1; 
                            }

                         
                            if (heightDifference > 0) {
                                adjustedMinY = minY - 1; 
                            }

                           
                            for (let x = minX; x <= maxX; x++) {
                                for (let y = adjustedMinY; y <= adjustedMaxY; y++) {
                                    for (let z = minZ; z <= maxZ; z++) {
                                        let delay = ((x - minX) * (adjustedMaxY - adjustedMinY + 1) * (maxZ - minZ + 1)) +
                                            ((y - adjustedMinY) * (maxZ - minZ + 1)) + (z - minZ);

                                        system.runTimeout(() => {
                                           
                                            

                                            
                                            player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run clear @s ${blockId} 0 1`);
                                            player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run setblock ${x} ${y} ${z} ${blockId}`);

                                            
                                            player.runCommand(`execute unless entity @s[hasitem={item=${blockId}}] run particle minecraft:villager_angry ${x} ${y} ${z}`);
                                        }, delay);
                                    }
                                }
                            }

                        }

                    }
                })
            })
            system.run(() => {
                eq.getEquipmentSlot("Mainhand").setLore([`${data.itemStack.getLore()[0]}`])
            })
        } else if (data.source.isSneaking == false) {
            system.run(() => {
                eq.getEquipmentSlot("Mainhand").setLore([`${data.itemStack.getLore()[0]}`, `${data.block.location.x} ${data.block.location.y} ${data.block.location.z} ${data.block.getItemStack().typeId}`])
            })


        }

    } else if (data.itemStack.typeId == "blayy:builder_wand") {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"text.fbw_wand_error"}]}`)
    }






})